// get all calculated value into the histogram
using namespace std;
#include<TROOT.h>
#include<iostream>
#include<heplist.h>
// CLHEP
#include "CLHEP/config/CLHEP.h"
#include "CLHEP/Vector/LorentzVector.h"
#include "CLHEP/Vector/Boost.h"
#include "CLHEP/Vector/Rotation.h"


extern heplist hep;      // get particles after the cuts


Int_t  user_afill( char * type, char * nnn, Double_t* getval, Long_t nc1=-1, Long_t nc2=-1);


// ----------------------- Fill stable hadrons 
Int_t  user_afill( char * type, char * nnn, double* getval, long nc1, long nc2) {
// example file: calculation of strange production & charm stuff (cross sections)


// to access information to fill histograms 
// Input:
// type="particle" - get varibales for separate particles or events
// type="jet"      - get informations on jets only
// nnn             - name of the histogram (should be given also in user-name.txt 
//                  to make such calculationas available)  
// nc1,nc2  - No of current particle 1 (single-particle density) and particle 2 (for 2-particle density)
//            if not filled - assumes -1 
//
// Output:
// getval - value to fill histogram

// as example, see system files 
//   $RUNMC/main/src/afill.cpp as example
//   $RUNMC/main/sys/system-histo.txt 



   *getval = -99999;


// below are example copied from $RUNMC/main/src/afill.cpp

// fill first varibles charcterising events ------------------------
   if (nc1==-1 && nc2==-1) {

     if (strcmp(nnn,"Put_here_some_title ") == 0)  {
// put calculations
     } else {
// do not do anything
     return 1; };

   }; // end filling event varibales


// fill first varibles charcterising single particles ------------------------
   if (nc1 != -1 && nc2==-1 && strcmp(type,"particle") == 0) {

// find K0s and Lambda and do kinematics
   if (strcmp(nnn,"Pt(K0s)")  == 0 && abs(hep.PP[nc1].id) == 310)
                                 { *getval=hep.PP[nc1].p.perp(); }
   else if (strcmp(nnn,"Eta(K0s)")  == 0 && abs(hep.PP[nc1].id) == 310)
                                { *getval=hep.PP[nc1].p.pseudoRapidity(); }
   else if (strcmp(nnn,"Pt(Lambda)")  == 0 && hep.PP[nc1].id == 3122)
                                 { *getval=hep.PP[nc1].p.perp(); }
   else if (strcmp(nnn,"Eta(Lambda)")  == 0 && hep.PP[nc1].id == 3122)
                                { *getval=hep.PP[nc1].p.pseudoRapidity(); }
   else if (strcmp(nnn,"Pt(antiLambda)")  == 0 && hep.PP[nc1].id == -3122)
                                 { *getval=hep.PP[nc1].p.perp(); }
   else if (strcmp(nnn,"Eta(antiLambda)")  == 0 && hep.PP[nc1].id == -3122)
                                { *getval=hep.PP[nc1].p.pseudoRapidity(); }
   else if (strcmp(nnn,"Pt(Lambda-all)")  == 0 && abs(hep.PP[nc1].id) == 3122)
                                 { *getval=hep.PP[nc1].p.perp(); }
   else if (strcmp(nnn,"Eta(Lambda-all)")  == 0 && abs(hep.PP[nc1].id) == 3122)
                                { *getval=hep.PP[nc1].p.pseudoRapidity(); }
   else if (strcmp(nnn,"Pt(Dstar)")  == 0 && abs(hep.PP[nc1].id) == 413)
                                 { *getval=hep.PP[nc1].p.perp(); }
   else if (strcmp(nnn,"Eta(Dstar)")  == 0 && abs(hep.PP[nc1].id) == 413)
                                { *getval=hep.PP[nc1].p.pseudoRapidity(); }

// do not do anything, if "nnn" does not match your calculation
   else {
       return 1;
   };


// put calculations 
   };
 
 
// fill first varibles charcterising 2-particle density (invarinat mass etc) ---------------
   if (nc1 != -1 && nc2 !=-1 && strcmp(type,"particle") == 0) {
// put calculations 
     if (strcmp(nnn,"Put_here_some_title ") == 0)  {
     } else {
// do not do anything
     return 1; };

   }; // end 2-particle densities

// fill jet varibales (1-particle densities)
   if (nc1 != -1 && nc2 ==-1 && strcmp(type,"jet") == 0) {
// put calculations
     if (strcmp(nnn,"Put_here_some_title ") == 0)  {
     } else {
// do not do anything
     return 1; };
   }; // put calculations

 
      return 0;
}
